<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class DamageMaster extends BaseModel
{
    use HasFactory;

    protected $guarded = [];

    protected static function boot()
    {
        parent::boot(); // always call the parent boot

        static::addGlobalScope('typeScope', function ($builder) {
            if (auth()->check() && auth()->user()->shop_id != null) {
                $builder->where('damage_masters.transition_location_id',  auth()->user()->shop_id)
                    ->orWhere('damage_masters.warehouse_id',  auth()->user()->shop_id);
            }
        });

        static::creating(function ($model) {
            if (auth()->check()) {
                $user = auth()->user();
                $model->transition_location_id = $user->shop_id;
                $model->transition_create_by = $user->id;
            }
        });

        static::updating(function ($model) {
            if (auth()->check()) {
                $model->transition_update_by = auth()->id(); // use user ID here
            }
        });
    }

    public function details()
    {
        return $this->hasMany(DamageDetalis::class, 'damage_id', 'id')->with('attribute', 'product', 'stock');
    }
}
